#
# spec file for package libkolabxml
#
# Copyright (c) 2016 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


%if 0%{?suse_version} < 1220
%define _without_java 1
%endif
%bcond_without java
%bcond_without mono
%bcond_with tests

%global php_extdir %{_libdir}/php5/extensions
%global php_confdir %{_sysconfdir}/php5/conf.d
%define libname %{name}1
Name:           libkolabxml
Version:        1.1.2
Release:        13.26
Summary:        Kolab XML Format Schema Definitions Library
License:        LGPL-3.0+
Group:          Development/Libraries/C and C++
Url:            https://kolab.org/about/libkolabxml
Source:         http://mirror.kolabsys.com/pub/releases/%{name}-%{version}.tar.gz
# PATCH-FIX-SLE libkolabxml-0.8.3_fix_uuid_includes_SLE.patch -- Fix uuid.h path on SLE 11
Patch0:         libkolabxml-0.8.3_fix_uuid_includes_SLE.patch
# PATCH-FIX-SLE libkolabxml-1.0.1_no-maybe-uninitialized.patch -- Fix php and python bindings on SLE 11
Patch2:         libkolabxml-1.0.1_no-maybe-uninitialized.patch
BuildRequires:  boost-devel >= 1.4.1
BuildRequires:  cmake >= 2.6
BuildRequires:  gcc-c++
BuildRequires:  libcurl-devel
BuildRequires:  libxerces-c-devel >= 3.0
BuildRequires:  php-devel >= 5.3
BuildRequires:  pkgconfig
BuildRequires:  python-devel
BuildRequires:  swig >= 2.0
BuildRequires:  xsd >= 3.0
%if 0%{?suse_version} < 1140
BuildRequires:  uuid-devel = 1.6.2
%endif
%if %{with java}
BuildRequires:  gcc-java
BuildRequires:  java-openjdk
%endif
%if %{with mono}
BuildRequires:  mono-devel
%endif
%if %{with tests}
%if 0%{?suse_version} > 1314
BuildRequires:  extra-cmake-modules
BuildRequires:  kdelibs4support-devel
BuildRequires:  pkgconfig(Qt5Core)
BuildRequires:  pkgconfig(Qt5Test)
%else 
BuildRequires:  libqt4-devel
%endif
%endif

BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
Libkolabxml serves as a serialization/de-serialization library for the the Kolab XML Format

Features:
- Based on official standards:
- Todos/Events/Journals are fully xCal compliant
- Contacts/Distributionlists are fully xCard compliant
- Can model everything which is used in the Kolab XML Format 2.0, Kontact and Roundcube.
- Easily extensible
- Canonical storage format
- Supports Todos/Events/Journals/Contacts/Distribution Lists/Notes/Configurations

%package -n %{libname}
Summary:        Kolab XML Format Schema Definitions Library
Group:          Development/Libraries/C and C++

%description -n %{libname}
Libkolabxml serves as a serialization/de-serialization library for the the Kolab XML Format

Features:
- Based on official standards:
- Todos/Events/Journals are fully xCal compliant
- Contacts/Distributionlists are fully xCard compliant
- Can model everything which is used in the Kolab XML Format 2.0, Kontact and Roundcube.
- Easily extensible
- Canonical storage format
- Supports Todos/Events/Journals/Contacts/Distribution Lists/Notes/Configurations

%package devel
Summary:        Kolab XML Format Schema Definitions Library
Group:          Development/Libraries/C and C++
Requires:       %{libname} = %{version}
Requires:       libcurl-devel

%description devel
Libkolabxml serves as a serialization/de-serialization library for the the Kolab XML Format

Features:
- Based on official standards:
- Todos/Events/Journals are fully xCal compliant
- Contacts/Distributionlists are fully xCard compliant
- Can model everything which is used in the Kolab XML Format 2.0, Kontact and Roundcube.
- Easily extensible
- Canonical storage format
- Supports Todos/Events/Journals/Contacts/Distribution Lists/Notes/Configurations

%package -n java-%{libname}
Summary:        Java bindings for %{name}
Group:          Development/Languages/Java
Requires:       %{libname} = %{version}
Provides:       java-kolabformat = %{version}

%description -n java-%{libname}
Libkolabxml serves as a serialization/de-serialization library for the the Kolab XML Format

Features:
- Based on official standards:
- Todos/Events/Journals are fully xCal compliant
- Contacts/Distributionlists are fully xCard compliant
- Can model everything which is used in the Kolab XML Format 2.0, Kontact and Roundcube.
- Easily extensible
- Canonical storage format
- Supports Todos/Events/Journals/Contacts/Distribution Lists/Notes/Configurations

This package provides the java bindings for Libkolabxml

%package -n mono-%{libname}
Summary:        Mono (C#) bindings for %{name}
Group:          Development/Languages/Mono
Requires:       %{libname} = %{version}
Provides:       csharp-kolabformat = %{version}

%description -n mono-%{libname}
Libkolabxml serves as a serialization/de-serialization library for the the Kolab XML Format

Features:
- Based on official standards:
- Todos/Events/Journals are fully xCal compliant
- Contacts/Distributionlists are fully xCard compliant
- Can model everything which is used in the Kolab XML Format 2.0, Kontact and Roundcube.
- Easily extensible
- Canonical storage format
- Supports Todos/Events/Journals/Contacts/Distribution Lists/Notes/Configurations

This package provides the mono (C#) bindings for Libkolabxml

%package -n php-%{libname}
Summary:        PHP bindings for %{name}
Group:          Development/Languages/Other
Requires:       %{libname} = %{version}
Provides:       php-kolabformat = %{version}

%description -n php-%{libname}
Libkolabxml serves as a serialization/de-serialization library for the the Kolab XML Format

Features:
- Based on official standards:
- Todos/Events/Journals are fully xCal compliant
- Contacts/Distributionlists are fully xCard compliant
- Can model everything which is used in the Kolab XML Format 2.0, Kontact and Roundcube.
- Easily extensible
- Canonical storage format
- Supports Todos/Events/Journals/Contacts/Distribution Lists/Notes/Configurations

This package provides the php bindings for Libkolabxml

%package -n python-%{libname}
Summary:        Python bindings for %{name}
Group:          Development/Languages/Python
Requires:       %{libname} = %{version}
Provides:       python-kolabformat = %{version}

%description -n python-%{libname}
Libkolabxml serves as a serialization/de-serialization library for the the Kolab XML Format

Features:
- Based on official standards:
- Todos/Events/Journals are fully xCal compliant
- Contacts/Distributionlists are fully xCard compliant
- Can model everything which is used in the Kolab XML Format 2.0, Kontact and Roundcube.
- Easily extensible
- Canonical storage format
- Supports Todos/Events/Journals/Contacts/Distribution Lists/Notes/Configurations

This package provides the python bindings for Libkolabxml

%prep
%setup -q
%if 0%{?suse_version} < 1140
%patch0
%patch2 -p1
%endif

%build
# cmake: with earlier releases, we have to create and cd manually, as %%cmake is not available
%if 0%{?suse_version} < 1310
%define cmake cmake
mkdir build
cd build
%endif

# libexecdir: SLE11 expands to libdir, but we want /usr/lib/
%if 0%{?suse_version} < 1140
%define _libexecdir %{_prefix}/lib
%endif

# Tests require X server and net
# no-undefined does not work as the php bindings are "magic"
%cmake \
    -DCMAKE_EXE_LINKER_FLAGS=-Wl,--as-needed \
    -DCMAKE_MODULE_LINKER_FLAGS=-Wl,--as-needed \
    -DCMAKE_SHARED_LINKER_FLAGS=-Wl,--as-needed \
%if %{with java}
    -DJAVA_BINDINGS=TRUE -DJAVA_INSTALL_DIR=%{_jnidir} \
%endif
    -DPHP_BINDINGS=TRUE -DPHP_INSTALL_DIR=%{php_extdir}\
    -DPYTHON_BINDINGS=TRUE -DPYTHON_INSTALL_DIR=%{python_sitearch} \
%if %{with mono}
    -DCSHARP_BINDINGS=TRUE -DCSHARP_INSTALL_DIR=%{_libexecdir}/mono/ \
%endif
%if %{with tests}
    -DBUILD_TESTS=TRUE \
%if 0%{?suse_version} > 1314
    -DBUILD_QT5=TRUE \
%endif
%else
    -DBUILD_TESTS=FALSE \
%endif
%if 0%{?suse_version} < 1310
    -DCMAKE_INSTALL_PREFIX="%{_prefix}" \
    -DLIB_INSTALL_DIR=%{_lib} \
    ..
%endif

make %{?_smp_mflags}

%install
# cmake: with earlier releases, we have to change dir manually, as %%cmake_install is not available
%if 0%{?suse_version} < 1310
cd build/
%{__make} DESTDIR=%{buildroot} install
%else
%cmake_install
%endif

mkdir -p %{buildroot}/%{_datadir}/php5
mv %{buildroot}/%{php_extdir}/kolabformat.php %{buildroot}/%{_datadir}/php5/kolabformat.php

mkdir -p %{buildroot}/%{php_confdir}/
cat >%{buildroot}/%{php_confdir}/kolabformat.ini <<EOF
extension=kolabformat.so
EOF

%if %{with tests}
%check
export LD_LIBRARY_PATH=$(pwd)/build/src/
cd build/
ctest -V ||:
python src/python/test.py ||:
%endif

%post   -n %{libname} -p /sbin/ldconfig

%postun -n %{libname} -p /sbin/ldconfig

%files -n %{libname}
%defattr(-,root,root)
%doc AUTHORS COPYING README
%{_libdir}/libkolabxml.so.*

%files -n python-%{libname}
%defattr(-,root,root)
%doc COPYING
%{python_sitearch}/_kolabformat.so
%{python_sitearch}/kolabformat.py*

%files -n php-%{libname}
%defattr(-,root,root)
%doc COPYING
%config(noreplace) %{php_confdir}/kolabformat.ini
%{_datadir}/php5/kolabformat.php
%{php_extdir}/kolabformat.so

%if %{with java}
%files -n java-%{libname}
%defattr(-,root,root)
%doc COPYING
%dir %{_libdir}/java/
%{_libdir}/java/*
%endif

%if %{with mono}
%files -n mono-%{libname}
%defattr(-,root,root)
%doc COPYING
%{_libexecdir}/mono/*
%endif

%files devel
%defattr(-,root,root)
%doc DEVELOPMENT
%dir %{_libdir}/cmake/
%{_libdir}/cmake/Libkolabxml/
%{_libdir}/libkolabxml.so
%{_includedir}/kolabxml/

%changelog
* Fri Jan  8 2016 tittiatcoke@gmail.com
- New upstream release 1.1.2
  - Build fixes for the tests (Qt5 related)
* Fri Aug  7 2015 tittiatcoke@gmail.com
- New upstream release 1.1.1
  - Qt5 support for the tests
* Mon Apr  6 2015 aj@ajaissle.de
- Add %%bcond_with tests
- libqt4-devel is only needed for the tests
- Add %%check section; only run %%check when %%{with tests} in on
- Set minversion for some of the build requirements
* Wed Apr  1 2015 aj@ajaissle.de
- New upstream release 1.1.0
- Drop patch (upstream inclusion):
  - libkolabxml-1.0.3_make_version_attribute_not_a_fixed_value.patch
* Sat Mar 28 2015 aj@ajaissle.de
- Add libkolabxml-1.0.3_make_version_attribute_not_a_fixed_value.patch:
  Instead of a fixed value, we only use a default value.
  Fixes problems where objects created with version string '3.0dev'
  can not be fetched/displayed.
- Convert %%with_java to %%bcond_without java
* Mon Mar 23 2015 schwab@suse.de
- Allow building without mono bindings
* Wed Dec 10 2014 aj@ajaissle.de
- Reenable building for non-Factory openSUSE
* Sat Nov  8 2014 hrvoje.senjan@gmail.com
- Revert the added Requires in devel subpackage from previous change:
  if someone needs bindings explicitly, they can buildrequire them
  explicitly
* Fri Nov  7 2014 tchvatal@suse.com
- Version bump to 1.0.3
- Cleanup with spec-cleaner
- no-undefined disabled as php-bindings cant cope with it
* Tue Aug 26 2014 aj@ajaissle.de
- New upstream release 1.0.2
- Dropped the following patches, as they're now included upstream:
  - libkolabxml-1.0.1_xsd_type.patch
  - libkolabxml-1.0.1_csharp_bindings.patch
* Mon Aug  4 2014 aj@ajaissle.de
- Added patch libkolabxml-1.0.1_xsd_type.patch
  - Fix compatibility with xsd 4.0.0
* Mon Nov 25 2013 aj@ajaissle.de
- libkolabxml-1.0.1_no-maybe-uninitialized.patch
  * Remove no-maybe-unititialized cxx flag from SLE builds (not supported)
- Renamed csharp_bindings.diff to libkolabxml-1.0.1_csharp_bindings.patch
- Renamed fix_uuid_includes_SLE.diff to libkolabxml-0.8.3_fix_uuid_includes_SLE.patch
* Thu Nov 21 2013 aj@ajaissle.de
- New upstream release 1.0.1
- soname changed from 0 to 1
* Wed Nov 20 2013 aj@ajaissle.de
- New upstream release 0.8.5
- csharp_bindings.diff: Fix csharp bindings
* Wed Nov 13 2013 aj@ajaissle.de
- Bindings require libkolabxml
* Sun Sep 15 2013 hrvoje.senjan@gmail.com
- Fix build for Factory - make java subpackage owns %%_libdir/java
  directory
* Wed Jun 19 2013 schwab@suse.de
- Make mono bindings optional
* Sat Jun  8 2013 aj@ajaissle.de
- Cleaning up spec file to reduce prjconf settings
* Mon Apr 29 2013 aj@ajaissle.de
- Removed fix_php5_bindings.diff
* Wed Apr 24 2013 aj@ajaissle.de
- New upstream version 0.8.4
  * Fixes an issue in the bindings generated (related to event vectors)
- Disabled fix_php5_bindings.diff (fixed in 0.8.4)
* Mon Apr 22 2013 aj@ajaissle.de
- Added fix_uuid_includes_SLE.diff
- removed sed command to fix uuid includes
- Patch only sles_version == 11
* Tue Mar 19 2013 aj@ajaissle.de
- Enable mono bindings for SLE 11 SP 2
* Tue Mar 19 2013 aj@ajaissle.de
- Use devel:tools:building when building SLE 11 SP2 (cmake, swig)
- Removed cmake cxx flag -Wno-maybe-uninitialized
- Fix php bindings for SLE 11 SP2
* Wed Mar 13 2013 aj@ajaissle.de
- Also include .pyo and .pyc files in python-kolabformat
* Fri Mar  1 2013 aj@ajaissle.de
- Updated spec fix SLE 11 SP2 build
* Wed Feb 27 2013 aj@ajaissle.de
- New upstream version 0.8.3
  * adds capabilities to read/write a new XML format
- Update fix_php5_bindings.diff
* Mon Jan 14 2013 aj@ajaissle.de
- Disabled php and mono bindings for SLES to fix the SLES build
* Thu Dec 20 2012 aj@ajaissle.de
- Added Patch: fix_php5_bindings.diff to fix php bindings
  * Patch to hack src/php/CMakeList.cmake to find PHP5 on openSUSE
* Tue Nov 20 2012 nico.kruber@gmail.com
- Fix the SLES build (%%make_install is not expanded on SLES)
* Thu Aug 16 2012 toddrme2178@gmail.com
- Update to 0.8.1
  * no changelog
- Java and Mono backends working and built now
- Removed upstream patches
* Sun Jul 22 2012 nico.kruber@gmail.com
- set LIB_INSTALL_DIR correctly
  (must be a relative path to the prefix)
  - > fixes wrong paths in LibkolabxmlConfig.cmake
- devel package requires libcurl-devel
* Sat Jul 21 2012 toddrme2178@gmail.com
- Add additional buildrequires
* Fri May  4 2012 cgiboudeaux@gmx.com
- Add libkolabxml 0.4.0
